Imports System.Drawing
Imports System.Drawing.Graphics

' Modified by Rod, 6/24/04.
#Const MODIFIED_BY_ROD = True

Public Class frmMain
    Inherits System.Windows.Forms.Form

#Region " Windows Form Designer generated code "

    Public Sub New()
        MyBase.New()

        'This call is required by the Windows Form Designer.
        InitializeComponent()

        'Add any initialization after the InitializeComponent() call

    End Sub

    'Form overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    'Required by the Windows Form Designer
    Private components As System.ComponentModel.IContainer

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.  
    'Do not modify it using the code editor.
    Friend WithEvents pnlImage As System.Windows.Forms.Panel
    Friend WithEvents tmr As System.Windows.Forms.Timer
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.components = New System.ComponentModel.Container
        Me.pnlImage = New System.Windows.Forms.Panel
        Me.tmr = New System.Windows.Forms.Timer(Me.components)
        Me.SuspendLayout()
        '
        'pnlImage
        '
        Me.pnlImage.Anchor = CType((((System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Bottom) _
                    Or System.Windows.Forms.AnchorStyles.Left) _
                    Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
        Me.pnlImage.Location = New System.Drawing.Point(0, 0)
        Me.pnlImage.Name = "pnlImage"
        Me.pnlImage.Size = New System.Drawing.Size(340, 252)
        Me.pnlImage.TabIndex = 0
        '
        'tmr
        '
        Me.tmr.Interval = 1000
        '
        'frmMain
        '
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
        Me.BackColor = System.Drawing.SystemColors.ControlText
        Me.ClientSize = New System.Drawing.Size(340, 252)
        Me.ControlBox = False
        Me.Controls.Add(Me.pnlImage)
        Me.FormBorderStyle = System.Windows.Forms.FormBorderStyle.None
        Me.MaximizeBox = False
        Me.MinimizeBox = False
        Me.Name = "frmMain"
        Me.ShowInTaskbar = False
        Me.StartPosition = System.Windows.Forms.FormStartPosition.Manual
        Me.Text = "Form1"
        Me.TopMost = True
        Me.WindowState = System.Windows.Forms.FormWindowState.Maximized
        Me.ResumeLayout(False)

    End Sub

#End Region

    Private intLast As Integer
    Private sFiles() As String

    Private Sub Form1_Paint(ByVal sender As Object, ByVal e As System.Windows.Forms.PaintEventArgs) Handles MyBase.Paint
#If MODIFIED_BY_ROD Then
        DrawTheImage()
#Else
        If intLast = sFiles.GetLength(0) Then intLast = 0
        Dim newImage As Bitmap = Bitmap.FromFile(sFiles(intLast))
        Dim PanelGraphic As Graphics = pnlImage.CreateGraphics

        PanelGraphic.Clear(Color.White)
        PanelGraphic.DrawImage(newImage, 0, 0, pnlImage.Width, pnlImage.Height)

        newImage.Dispose()
        PanelGraphic.Dispose()
        intLast += 1
#End If
    End Sub

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        If action = modMain.ActionType.actRun Then
            Cursor.Hide()
        Else
            RemoveHandler pnlImage.MouseMove, AddressOf pnlImage_MouseMove
            RemoveHandler frmMain.KeyDown, AddressOf Form1_KeyDown
        End If
        sFiles = imgSettings.GetFileList

        tmr.Interval = imgSettings.PhotoSpeed * 1000
        tmr.Enabled = True
    End Sub

    Private Sub tmr_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tmr.Tick
#If MODIFIED_BY_ROD Then
        DrawTheImage()
#Else
        If intLast = sFiles.GetLength(0) Then intLast = 0
        Dim newImage As Bitmap = Bitmap.FromFile(sFiles(intLast))
        Dim PanelGraphic As Graphics = pnlImage.CreateGraphics

        PanelGraphic.Clear(Color.White)
        PanelGraphic.DrawImage(newImage, 0, 0, pnlImage.Width, pnlImage.Height)

        newImage.Dispose()
        PanelGraphic.Dispose()
        intLast += 1
#End If
    End Sub

    Private Sub Form1_KeyDown(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyEventArgs) Handles MyBase.KeyDown
        Application.Exit()
    End Sub

    Private Sub pnlImage_MouseMove(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles pnlImage.MouseMove
        Static done_before As Boolean
        Static mouse_x As Long
        Static mouse_y As Long
        If Not done_before Then
            done_before = True
            mouse_x = e.X
            mouse_y = e.Y
        Else
            If Math.Abs(e.X - mouse_x) > 10 Or Math.Abs(e.Y - mouse_y) Then
                Application.Exit()
            End If
        End If
    End Sub

    ' Draw the image as large as possible without distortion.
    Private Sub DrawTheImage()
        Dim PanelGraphic As Graphics = pnlImage.CreateGraphics
        PanelGraphic.Clear(Color.Black)
        Try
            If intLast = sFiles.GetLength(0) Then intLast = 0
            Dim newImage As Bitmap = Bitmap.FromFile(sFiles(intLast))

            Dim x As Integer
            Dim y As Integer
            Dim wid As Integer
            Dim hgt As Integer
            If (newImage.Height / newImage.Width) > (pnlImage.Height / pnlImage.Width) Then
                ' The new image is relatively tall and thin.
                ' Make the image as tall as possible.
                hgt = pnlImage.ClientSize.Height
                wid = CInt(hgt * newImage.Width / newImage.Height)
            Else
                ' The new image is relatively short and wide.
                ' Make the image as wide as possible.
                wid = pnlImage.ClientSize.Width
                hgt = CInt(wid * newImage.Height / newImage.Width)
            End If

            x = (pnlImage.Width - wid) \ 2
            y = (pnlImage.Height - hgt) \ 2
            PanelGraphic.DrawImage(newImage, x, y, wid, hgt)

            newImage.Dispose()
            PanelGraphic.Dispose()
            intLast += 1
        Catch ex As Exception
            DrawErrorImage()
        End Try
    End Sub

    Private Sub DrawErrorImage()
        Dim PanelGraphic As Graphics = pnlImage.CreateGraphics
        PanelGraphic.Clear(Color.Black)
        Dim the_pen As New Pen(Color.Red, 10)
        PanelGraphic.DrawLine(the_pen, _
            0, 0, _
            pnlImage.ClientSize.Width, pnlImage.ClientSize.Height)
        PanelGraphic.DrawLine(the_pen, _
            pnlImage.ClientSize.Width, 0, _
            0, pnlImage.ClientSize.Height)
        the_pen.Dispose()
    End Sub
End Class
